#include "bits/stdc++.h"

using namespace std;

#define int long long

void solve(){
    cout << fixed << setprecision(9);
    int n,m;
    cin >> n >> m;

    long double r;
    cin >> r;

    vector<pair<int,int>> s(n+1);
    vector<long double> x(n + 1);

    for (int i = 1;i <= n;i++){
        cin >> s[i].first >> s[i].second;
    }

    std::sort(s.begin(), s.end());

    for (int i = 1;i <= n;i++){
        x[i] = x[i-1] * pow(1-r,s[i].first - s[i-1].first) + s[i].second * r;
    }

//    for (const auto &item: x){
//        cout << item << " ";
//    }

    for (int i = 0;i < m;i++) {
        int q;
        cin >> q;
        int l = 0, r1 = s.size();

        while (r1 - l > 1) {
            int mid = (l + r1) / 2;

            if (s[mid].first <= q) l = mid;
            else r1 = mid;
        }

        cout << x[l] * pow(1 - r,q - s[l].first) << " ";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;

    while (t--) solve();
}
